
function http_build_query(formdata, numeric_prefix, arg_separator) {
	var value, key, tmp = [];

	var _http_build_query_helper = function (key, val, arg_separator) {
		var k, tmp = [];
		if (val === true) {
			val = "1";
		} else if (val === false) {
			val = "0";
		}
		if (val !== null && typeof(val) === "object") {
			for (k in val) {
				if (val[k] !== null) {
					tmp.push(_http_build_query_helper(key + "[" + k + "]", val[k], arg_separator));
				}
			}
			return tmp.join(arg_separator);
		} else if (typeof(val) !== "function") {
			return this.urlencode(key) + "=" + this.urlencode(val);
		} else {
			throw new Error('There was an error processing for http_build_query().');
		}
	};

	if (!arg_separator) {
		arg_separator = "&";
	}
	for (key in formdata) {
		value = formdata[key];
		if (numeric_prefix && !isNaN(key)) {
			key = String(numeric_prefix) + key;
		}
		tmp.push(_http_build_query_helper(key, value, arg_separator));
	}

	return tmp.join(arg_separator);
}

function urlencode(str) {
	str = (str+'').toString();
	return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').
																	replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
}


function urldecode(str) {
	return decodeURIComponent((str+'').replace(/\+/g, '%20'));
}

function parse_str(str, array){
   var glue1 = '=', glue2 = '&', array2 = String(str).replace(/^&?([\s\S]*?)&?$/, '$1').split(glue2),
	i, j, chr, tmp, key, value, bracket, keys, evalStr, that = this,
	fixStr = function (str) {
		return that.urldecode(str).replace(/([\\"'])/g, '\\$1').replace(/\n/g, '\\n').replace(/\r/g, '\\r');
	};

	if (!array) {
		array = this.window;
	}

	for (i = 0; i < array2.length; i++) {
		tmp = array2[i].split(glue1);
		if (tmp.length < 2) {
			tmp = [tmp, ''];
		}
		key   = fixStr(tmp[0]);
		value = fixStr(tmp[1]);
		while (key.charAt(0) === ' ') {
			key = key.substr(1);
		}
		if (key.indexOf('\0') !== -1) {
			key = key.substr(0, key.indexOf('\0'));
		}
		if (key && key.charAt(0) !== '[') {
			keys	= [];
			bracket = 0;
			for (j = 0; j < key.length; j++) {
				if (key.charAt(j) === '[' && !bracket) {
					bracket = j + 1;
				}
				else if (key.charAt(j) === ']') {
					if (bracket) {
						if (!keys.length) {
							keys.push(key.substr(0, bracket - 1));
						}
						keys.push(key.substr(bracket, j - bracket));
						bracket = 0;
						if (key.charAt(j + 1) !== '[') {
							break;
						}
					}
				}
			}
			if (!keys.length) {
				keys = [key];
			}
			for (j = 0; j < keys[0].length; j++) {
				chr = keys[0].charAt(j);
				if (chr === ' ' || chr === '.' || chr === '[') {
					keys[0] = keys[0].substr(0, j) + '_' + keys[0].substr(j + 1);
				}
				if (chr === '[') {
					break;
				}
			}
			evalStr = 'array';
			for (j = 0; j < keys.length; j++) {
				key = keys[j];
				if ((key !== '' && key !== ' ') || j === 0) {
					key = "'" + key + "'";
				}
				else {
					key = eval(evalStr + '.push([]);') - 1;
				}
				evalStr += '[' + key + ']';
				if (j !== keys.length - 1 && eval('typeof ' + evalStr) === 'undefined') {
					eval(evalStr + ' = [];');
				}
			}
			evalStr += " = '" + value + "';\n";
			eval(evalStr);
		}
	}
}




function parse_url(str, component) {
	var  o   = {
		strictMode: false,
		key: ["source","protocol","authority","userInfo","user","password","host","port","relative","path","directory","file","query","anchor"],
		q:   {
			name:   "queryKey",
			parser: /(?:^|&)([^&=]*)=?([^&]*)/g
		},
		parser: {
			strict: /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
			loose:  /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/\/?)?((?:(([^:@]*):?([^:@]*))?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/ // Added one optional slash to post-protocol to catch file:/// (should restrict this)
		}
	};
	
	var m   = o.parser[o.strictMode ? "strict" : "loose"].exec(str),
	uri = {},
	i   = 14;
	while (i--) {
		//экранируем '/'
		if (typeof(m[i]) != 'undefined'){
			m[i] = m[i].replace(/\//g, '');
		}
		uri[o.key[i]] = m[i] || "";
	}
	// Uncomment the following to use the original more detailed (non-PHP) script
	/*
		uri[o.q.name] = {};
		uri[o.key[12]].replace(o.q.parser, function ($0, $1, $2) {
		if ($1) uri[o.q.name][$1] = $2;
		});
		return uri;
	*/

	switch (component) {
		case 'PHP_URL_SCHEME':
			return uri.protocol;
		case 'PHP_URL_HOST':
			return uri.host;
		case 'PHP_URL_PORT':
			return uri.port;
		case 'PHP_URL_USER':
			return uri.user;
		case 'PHP_URL_PASS':
			return uri.password;
		case 'PHP_URL_PATH':
			return uri.path;
		case 'PHP_URL_QUERY':
			return uri.query;
		case 'PHP_URL_FRAGMENT':
			return uri.anchor;
		default:
			var retArr = {};
			if (uri.protocol !== '') {retArr.scheme=uri.protocol;}
			if (uri.host !== '') {retArr.host=uri.host;}
			if (uri.port !== '') {retArr.port=uri.port;}
			if (uri.user !== '') {retArr.user=uri.user;}
			if (uri.password !== '') {retArr.pass=uri.password;}
			if (uri.path !== '') {retArr.path=uri.path;}
			if (uri.query !== '') {retArr.query=uri.query;}
			if (uri.anchor !== '') {retArr.fragment=uri.anchor;}
			return retArr;
	}
}
/* function get count elements in Object*/
function getCount(obj){
	var count = 0;
	var i;

	for (i in obj) {
	    if (obj.hasOwnProperty(i)) {
	        count++;
	    }
	}
	return count;
}

if (typeof(my_hop_host) == 'undefined') my_hop_host = location.host;

var aff_id = 0, ad_id = 0, contact_id = 0, jc_tags = {};

var utm_aff_id = 0, utm = {}; //параметры авторской или партнерской ссылки

var url = window.location.href;
if(url.substr(-1) == '/') url = url.substr(0, url.length - 1);
var _u = parse_url(url);

var _qw = {};
if (typeof(_u.query) != 'undefined')
{
	var _qw2 = {};
	parse_str(_u.query, _qw2);

	for (i in _qw2)
	{
		var re0 = /^p([1-9][0-9]{0,19})$/;
		var re1 = /^a([1-9][0-9]{0,19})$/;
		var re2 = /^r([1-9][0-9]{0,19})$/;
		var re3 = /^c([1-9][0-9]{0,19})$/;
		
		//список параметров утм-метки
		var re4 = /^(utm_source|utm_medium|utm_term|utm_content|utm_campaign|aff_source|aff_medium|aff_campaign|aff_content|aff_term)$/;

		if      (re0.test(i)) aff_id     = parseInt(i.substr(1));
		else if (re1.test(i)) 
			utm_aff_id = parseInt(i.substr(1));
		else if (re2.test(i)) ad_id      = parseInt(i.substr(1));
		else if (re3.test(i)) contact_id = parseInt(i.substr(1));
		else if(re4.test(i)) 
			utm[i] = _qw2[i].toLowerCase();//все переводим в нижний регистр
		else                  _qw[i]     = _qw2[i];
	}
} else jc_tags = false;

var _pos;
if ((_pos=url.indexOf('?')) > 0) url = url.substr(0, _pos);
_u.query = http_build_query(_qw);

if (_u.query != '') url += '?'+_u.query;

cntUtm = getCount(utm);
if (aff_id != 0 || ad_id != 0 || contact_id != 0 || cntUtm != 0 || utm_aff_id != 0)
{
	var click_qw = {};

	if (aff_id != 0) click_qw.aff = aff_id;
	if (ad_id != 0) click_qw.ad = ad_id;
	if (contact_id != 0) click_qw.contact = contact_id;
	
	if (cntUtm !== 0) 
		click_qw.utm = utm;
	if (utm_aff_id != 0) 
		click_qw.aff = utm_aff_id;
	
	//проверяем утм-метки или старые метки, в зависимости от этого определяем какой контроллер нужен
	if(cntUtm !== 0 || utm_aff_id != 0)
		controller = 'utm';
	else
		controller = 'click';
			
	var gas = document.createElement('script');
	gas.type = 'text/javascript';
	gas.async = true;
	gas.src = 'http://'+my_hop_host+'/'+controller+'/?'+http_build_query(click_qw);
	var s = document.getElementsByTagName('script')[0];
	s.parentNode.insertBefore(gas, s);
	
}
